﻿using System;
using System.Drawing;
using System.Windows.Forms;

namespace TestProject
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : Form
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 눈송이 카운트
        /// </summary>
        private readonly int snowflakeCount = 40;

        /// <summary>
        /// 눈송이 배열
        /// </summary>
        private Snowflake[] snowflakeArray;

        /// <summary>
        /// 인덱스
        /// </summary>
        private int index = 0;

        /// <summary>
        /// 타이머
        /// </summary>
        private Timer timer;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            Load += Form_Load;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 폼 로드시 처리하기 - Form_Load(sender, e)

        /// <summary>
        /// 폼 로드시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void Form_Load(object sender, EventArgs e)
        {
            Location        = new Point(0, 0);
            Size            = Screen.PrimaryScreen.Bounds.Size + (new Size(20, 20));
            TopMost         = true;
            FormBorderStyle = FormBorderStyle.None;
            BackColor       = Color.Black;
            TransparencyKey = Color.Black;

            this.snowflakeArray = new Snowflake[this.snowflakeCount];

            this.timer = new Timer();

            this.timer.Interval = 1000;

            this.timer.Tick += timer_Tick;

            this.timer.Start();
        }

        #endregion
        #region 타이머 틱 처리하기 - timer_Tick(sender, e)

        /// <summary>
        /// 타이머 틱 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void timer_Tick(object sender, EventArgs e)
        {
            if(this.index >= this.snowflakeCount)
            {
                this.timer.Stop();

                return;
            }

            this.snowflakeArray[index] = new Snowflake();

            Controls.Add(this.snowflakeArray[this.index]);

            this.index++;
        }

        #endregion
    }
}