﻿using System;
using System.Drawing;
using System.Windows.Forms;

namespace TestProject
{
    /// <summary>
    /// 눈송이
    /// </summary>
    public class Snowflake : PictureBox
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 난수기
        /// </summary>
        private Random random = new Random();

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - Snowflake()

        /// <summary>
        /// 생성자
        /// </summary>
        public Snowflake()
        {
            Create();

            Move();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region 타이머 틱 처리하기 - timer_Tick(sender, e)

        /// <summary>
        /// 타이머 틱 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void timer_Tick(object sender, EventArgs e)
        {
            Location += new Size(1, 3);

            if(Location.X > Screen.PrimaryScreen.Bounds.Width || Location.Y > Screen.PrimaryScreen.Bounds.Height)
            {
                Location = new Point
                (
                    this.random.Next(-Screen.PrimaryScreen.Bounds.Width , Screen.PrimaryScreen.Bounds.Width ),
                    this.random.Next(-Screen.PrimaryScreen.Bounds.Height, Screen.PrimaryScreen.Bounds.Height)
                );
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Function

        #region 생성하기 - Create()

        /// <summary>
        /// 생성하기
        /// </summary>
        private void Create()
        {
            Location        = new Point
            (
                this.random.Next(-Screen.PrimaryScreen.Bounds.Width , Screen.PrimaryScreen.Bounds.Width ),
                this.random.Next(-Screen.PrimaryScreen.Bounds.Height, Screen.PrimaryScreen.Bounds.Height)
            );
            MinimumSize     = new Size(7, 7);
            Size            = new Size(10, 10);
            BackgroundImage = Image.FromFile("snowflake.jpg");
        }

        #endregion
        #region 이동하기 - Move()

        /// <summary>
        /// 이동하기
        /// </summary>
        private new void Move()
        {
            Timer timer = new Timer();

            timer.Interval = 40;

            timer.Tick += timer_Tick;

            timer.Start();
        }

        #endregion
    }
}